//############################################################################//
unit mgupgrades;
interface
uses UResearchUpgrade;
const
no_research=NO_RESEARCH_AVAILABLE;
no_upgrade=NO_PRICE_AVAILABLE;
//############################################################################//
// ut values:
// Hitpoints = 0
// Armor     = 1
// Ammo      = 2
// Attack    = 3
// Speed     = 4
// Shots     = 5
// Range     = 6
// Scan      = 7
// Cost      = 8
// values can be changed. Update function get_ut for sync value changes
//############################################################################//
// Researches
function get_rsrch_inc(bv,rl,ut,mpt:integer):integer;
function get_rstch_turns(rl,ut:integer):integer;
function get_rsrch_lev_inc(): integer;
//############################################################################//
// Upgrades
function calc_gold(cv,bv,ut,rl:integer):integer;
function calc_gold_sum(bv,cv,nv,rl,ut:integer):integer;
function get_upgr_inc(bv:integer):integer;
function get_mat_for_upgr(cost:integer):integer;
//############################################################################//
implementation
//###################### Utility functions ###################################//
function get_ut(ut:integer):TUpgradeTypes;begin result:=TUpgradeTypes(ut); end;
//######################### Researches #######################################//
function get_rsrch_inc(bv,rl,ut,mpt:integer):integer;begin result:=CalcChangeByResearch(bv,rl,get_ut(ut),mpt);end;
function get_rstch_turns(rl,ut:integer):integer;begin result:=CalcResearchTurns(rl,get_ut(ut));end;
function get_rsrch_lev_inc():integer;begin result:=CalcIncreaseByResearch();end;
//########################## Upgrades ########################################//
function calc_gold(cv,bv,ut,rl:integer):integer;begin result:=CalcPrice(cv,bv,get_ut(ut),rl);end;
function calc_gold_sum(bv,cv,nv,rl,ut:integer):integer;begin result:=GetCostForUpgrade(bv,cv,nv,rl,get_ut(ut));end;
function get_upgr_inc(bv:integer):integer;begin result:=CalcIncreaseByUpgrade(bv);end;
function get_mat_for_upgr(cost:integer):integer;begin result:=GetMaterialCostForUpgrading(cost);end;
//############################################################################//
begin
end.
//############################################################################//
end.

